/*
 * Created on 2004/06/27
 * 
 * Author aki@www.xucker.jpn.org License Apache2.0 or Common Public License
 */
package org.jpn.xucker.findsame;

import java.io.File;
import java.io.IOException;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;

import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;

public class FindSameFileMain implements SelectionListener,Runnable {
    /**
     * @param shell
     */
    private Group group1;

    private Label label1;

    private Button button1;

    private Button fileNameCheckbox;
    private Button fileContainCheckbox;
    private Button IgnoreBaseFileCheckbox;
    private Label label2;

    private Button button3;

    private Button searchButton;

    private Group group2;

    private Label label3;

    private Table resultTable;

    private Shell shell;

    private String rootMD5;
    private String rootFileName;
    private ProgressBar progressBar;

    private int progressBarCurrent;

    private File searchDir;

    private boolean isFileNameCheck;

    private boolean isFileContainCheck;

    private boolean isIgnoreBaseFile;

    private String rootFileString;
    public FindSameFileMain(Shell shell){
        Image icon = new Image(Display.getCurrent(), FindSameFolderMain.class.getClassLoader()
                .getResourceAsStream(
                        "org/jpn/xucker/findsame/resource/blue.png"));
        shell.setImage(icon);
        this.shell = shell;
        shell.setText("FindFile:t@C");
        shell.setBounds(0, 0, 500, 400);
        RowLayout layout = new RowLayout();

        shell.setLayout(layout);
        group1 = new Group(shell, SWT.NULL);

        group1.setText("TΏ");
        RowData group1_data = new RowData();
        group1_data.width = 480;
        group1.setLayoutData(group1_data);

        RowLayout group1_layout = new RowLayout();
        group1_layout.wrap = true;
        group1.setLayout(group1_layout);

        label1 = new Label(group1, SWT.NULL);
        label1.setText("");
        RowData label1_data = new RowData();

        label1_data.width = 350;
        label1.setLayoutData(label1_data);

        button1 = new Button(group1, SWT.NULL);
        button1.setText("Tt@C");
        button1.addSelectionListener(this);
        RowData button1_data = new RowData();
        button1.setLayoutData(button1_data);

        fileNameCheckbox = new Button(group1, SWT.NULL | SWT.CHECK);
        fileNameCheckbox.setText("t@C");
        fileNameCheckbox.addSelectionListener(this);
        RowData checkbox2_data = new RowData();
        //checkbox2_data.width = 120;
        fileNameCheckbox.setLayoutData(checkbox2_data);
        
        fileContainCheckbox = new Button(group1, SWT.NULL | SWT.CHECK);
        fileContainCheckbox.setText("g(binary`FbN)");
        fileContainCheckbox.addSelectionListener(this);
        fileContainCheckbox.setSelection(true);
        RowData checkbox3_data = new RowData();
        //checkbox3_data.width = 120;
        fileContainCheckbox.setLayoutData(checkbox3_data);
        
        IgnoreBaseFileCheckbox = new Button(group1, SWT.NULL | SWT.CHECK);
        IgnoreBaseFileCheckbox.setText("T̃t@C͖");
        IgnoreBaseFileCheckbox.addSelectionListener(this);
        IgnoreBaseFileCheckbox.setSelection(true);
        RowData checkbox4_data = new RowData();
       // checkbox4_data.width = 120;
        IgnoreBaseFileCheckbox.setLayoutData(checkbox4_data);
        

        label2 = new Label(group1, SWT.NULL);
        label2.setText("");
        RowData label2_data = new RowData();
        label2_data.width = 350;
        label2.setLayoutData(label2_data);

        button3 = new Button(group1, SWT.NULL);
        button3.setText("TtH_[Q");
        button3.addSelectionListener(this);
        RowData button3_data = new RowData();
        button3.setLayoutData(button3_data);

        searchButton = new Button(shell, SWT.NULL);
        searchButton.setText("T");
        searchButton.addSelectionListener(this);
        RowData button4_data = new RowData();
        button4_data.width = 100;
        searchButton.setLayoutData(button4_data);
        searchButton.setEnabled(false);
        
        group2 = new Group(shell, SWT.NULL);
        group2.setText("");
        RowData group2_data = new RowData();
        group2_data.width = 480;
        group2.setLayoutData(group2_data);
        RowLayout group2_layout = new RowLayout();
        group2_layout.wrap = true;
        group2.setLayout(group2_layout);
        progressBar=new ProgressBar(group2,SWT.NULL);
        RowData progress_data=new RowData();
        progress_data.width=470;
        progressBar.setLayoutData(progress_data);

        label3 = new Label(group2, SWT.NULL);
        label3.setText("");
        RowData label3_data = new RowData();
        label3_data.width = 470;
        label3.setLayoutData(label3_data);

        resultTable = new Table(group2, SWT.NULL);
        resultTable.addSelectionListener(this);
        RowData table5_data = new RowData();
        table5_data.height=180;
        resultTable.setLayoutData(table5_data);
        TableColumn table5_column = new TableColumn(resultTable, SWT.NULL);
        table5_column.setWidth(455);
        resultTable.setFocus();
        

       // label1.setText("c:\\tmp\\aaa\\000.png");
        //label2.setText("c:\\tmp\\aaa");
    }

    public static void main(String[] args) {
        Display display = new Display();
        Shell shell = new Shell(display);

        FindSameFileMain main = new FindSameFileMain(shell);

        shell.open();

        while (!shell.isDisposed()) {
            if (!display.readAndDispatch()) {
                display.sleep();
            }
        }
        display.dispose();
    }

    public void widgetSelected(SelectionEvent event) {
        Object target = event.getSource();
        if (target == null) {
            //
        } else if (target == label1) {
            do_label1();
        } else if (target == button1) {
            do_openFile();
        } else if (target == fileNameCheckbox) {
            searchButtonEnableCheck();
        } else if (target == fileContainCheckbox) {
            searchButtonEnableCheck();
        }else if (target == IgnoreBaseFileCheckbox) {
            do_checkbox3();
        } else if (target == label2) {
            do_label2();
        } else if (target == button3) {
            do_openDir();
        } else if (target == searchButton) {
            do_search();
        } else if (target == label3) {
            do_label3();
        } else if (target == resultTable) {
            do_table5();
        }

    }

    /**
     * 
     */
    private void do_checkbox3() {
        searchButtonEnableCheck();
    }

    public void widgetDefaultSelected(SelectionEvent arg0) {
        // TODO Auto-generated method stub

    }

    public void do_label1() {
        System.out.println("label1");
    }

    public void do_openFile() {
        FileDialog dialog = new FileDialog(shell, SWT.OPEN);
        String file = dialog.open();
        if (file != null) {
            label1.setText(file);
        }
        searchButtonEnableCheck();
    }

    /**
     * 
     */
    private void searchButtonEnableCheck() {
      boolean enable=false;
        if(fileContainCheckbox.getSelection() || fileNameCheckbox.getSelection()){
          enable=true;
        }
        
        if(label1.getText().equals("") || label2.getText().equals("")){
            enable=false;
        }
          searchButton.setEnabled(enable);
    }

    

    public void do_label2() {
        System.out.println("label2");
    }

    public void do_openDir() {
        DirectoryDialog dialog = new DirectoryDialog(shell, SWT.OPEN);
        String file = dialog.open();
        if (file != null) {
            label2.setText(file);
        }
        searchButtonEnableCheck();
    }

    public void do_search() {
       
        File file=new File(label1.getText());
        
        File dir=new File(label2.getText());
        if(file.exists() && dir.exists()){
            try {
                if(fileNameCheckbox.getSelection()){
                    rootFileName=file.getName();
                }
                
                if(fileContainCheckbox.getSelection()){
                    rootMD5=MD5Util.toMD5(file);    
                }
                
                searchDir=new File(label2.getText());
                isFileNameCheck=fileNameCheckbox.getSelection();
                isFileContainCheck=fileContainCheckbox.getSelection();
                isIgnoreBaseFile=IgnoreBaseFileCheckbox.getSelection();
                rootFileString=label1.getText();
                Thread thread=new Thread(this);
                thread.start();
                
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
            
        }
    }

    /**
     * 
     */
    private void endSearch() {
        int count=resultTable.getItemCount();
        label3.setText(toLabel(count));
        
        button1.setEnabled(true);
        button3.setEnabled(true);
        fileContainCheckbox.setEnabled(true);
        fileNameCheckbox.setEnabled(true);
        IgnoreBaseFileCheckbox.setEnabled(true);
        searchButton.setEnabled(true);
        searchButtonEnableCheck();
    }

    /**
     * 
     */
    private void startSearch() {
       
        label3.setText("");
        button1.setEnabled(false);
        button3.setEnabled(false);
        fileContainCheckbox.setEnabled(false);
        fileNameCheckbox.setEnabled(false);
        IgnoreBaseFileCheckbox.setEnabled(false);
        searchButton.setEnabled(false);
        resultTable.removeAll();
        
        initProgressBar();
    }

    /**
     * 
     */
    private void initProgressBar() {
        // TODO Auto-generated method stub
        progressBar.setSelection(0);
        progressBar.redraw();
        File dir=new File(label2.getText());
        int result=FileUtil.countFile(dir);
        progressBar.setMinimum(0);
        progressBar.setMaximum(result);
        
        progressBarCurrent=0;
        
    }
    

    /**
     * @param dir
     * @return
     */
    

    /**
     * @param count
     * @return
     */
    private String toLabel(int count) {
        String label="t@ĆA܂łB";
        if(count>0){
            label=""+count+"  t@C܂B";
        }
        return label;
    }

    /**
     * @param dir
     */
    private void searchFile(File file) {
        if(file.isDirectory()){
            String list[]=file.list();
            if(list!=null){
            for (int i = 0; i < list.length; i++) {
                searchFile(new File(file,list[i]));
            }
            }
        }else{
            String md5;
            boolean isMutch=true;
            try {
                if(isFileNameCheck){
                   if(!rootFileName.equals(file.getName())){
                       isMutch=false;
                   }
                }
                
                if(isMutch && isFileContainCheck){
                    
                    md5 = MD5Util.toMD5(file);
                    if(!md5.equals(rootMD5)){
                       isMutch=false;
                    }
                }
                
                
                
                if(isMutch){
                    addFindFile(file);
                }
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
          
            shell.getDisplay().syncExec(new UpdateProgress());

        }
    }

    public void incrementProgressBar(){
        progressBarCurrent++;
        progressBar.setSelection(progressBarCurrent);
    }
    /**
     * @param file
     */
    private void addFindFile(File file) {
       if(isIgnoreBaseFile){
           File root=new File(rootFileString);
           if(file.getAbsolutePath().equals(root.getAbsolutePath())){
               return;
           }
       }
       AddTab addTab=new AddTab();
       addTab.setFile(file);
       
       shell.getDisplay().syncExec(addTab);
    }

    public void do_label3() {
        System.out.println("label3");
    }

    public void do_table5() {
        System.out.println("table5");
    }

    /* (non-Javadoc)
     * @see java.lang.Runnable#run()
     */
    public void run() {
        
        shell.getDisplay().syncExec(new StartSearch());
        searchFile(searchDir);
        shell.getDisplay().syncExec(new EndSearch());
    }
    
    public class UpdateProgress implements Runnable{
        public void run(){
            incrementProgressBar();
        }
    }
    
    
    public class StartSearch implements Runnable{
        public void run(){
            startSearch();
        }
    }
    
    public class EndSearch implements Runnable{
        public void run(){
            endSearch();
        }
    }
    public class AddTab implements Runnable{
        private File file;
        public File getFile() {
            return file;
        }
        public void setFile(File file) {
            this.file = file;
        }
        public void run(){
            TableItem item=new TableItem(resultTable,SWT.NULL);
            item.setText(file.getAbsolutePath());
            resultTable.redraw();
        }
    }

}