/*
 * Created on 2004/07/10
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.findsame;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.Hashtable;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;

/**
 * 
 *  
 */
public class FindSameFolderMain implements SelectionListener {

    Shell shell;

    Table table;

    Table resultTable;

    Label resultLabel;

    Menu popMenu;

    Image okImage;

    Image ngImage;

    Image yetImage;

    Hashtable rootHash;

    Hashtable errorHash;

    Label rootLabel;

    /**
     * @param args
     * @param shell
     */
    public FindSameFolderMain(String[] args, Shell shell) {
        Image icon = new Image(Display.getCurrent(), FindSameFolderMain.class.getClassLoader()
                .getResourceAsStream(
                        "org/jpn/xucker/findsame/resource/green.png"));
        shell.setImage(icon);
        initImage();
        errorHash = new Hashtable();
        this.shell = shell;
        shell.setText("FindSame:tH_[Pʔׂ");
        //shell.setBounds(0,0,400,330);
        shell.setLayout(new FillLayout(SWT.VERTICAL));

        TabFolder tab = new TabFolder(shell, SWT.NULL);
        tab.addSelectionListener(this);
        TabItem folderTab = new TabItem(tab, SWT.NULL);
        folderTab.setText("tH_[I");
        Composite panel = new Composite(tab, SWT.NULL);
        panel.setLayout(new GridLayout());
        folderTab.setControl(panel);
        Composite topPanel = new Composite(panel, SWT.NULL);
        rootLabel = new Label(topPanel, SWT.BORDER);
        rootLabel.setSize(400, 20);
        Button rootButton = new Button(topPanel, SWT.NULL);
        rootButton.setBounds(405, 0, 40, 20);
        rootButton.setText("I");
        rootButton.addSelectionListener(this);
        
        
        Button refreshButton = new Button(topPanel, SWT.NULL);
        refreshButton.setBounds(445, 0, 80, 20);
        refreshButton.setText("ēǂݍ");
        refreshButton.addSelectionListener(this);

        table = new Table(panel, SWT.FULL_SELECTION);
        TableColumn tc = new TableColumn(table, SWT.NULL);
        tc.setWidth(480);

        GridData gdata = new GridData();
        gdata.horizontalAlignment = GridData.FILL;
        gdata.verticalAlignment = GridData.FILL;
        gdata.widthHint = 500;
        gdata.heightHint = 300;
        table.setLayoutData(gdata);

        //centerPanel.setLayout(new GridLayout());

        TabItem resultTab = new TabItem(tab, SWT.NULL);
        
        resultTab.setText("ʏڍ");

        Composite resultPanel = new Composite(tab, SWT.NULL);
        resultPanel.setLayout(new GridLayout());

        resultLabel = new Label(resultPanel, SWT.NULL);
        GridData gdata2 = new GridData();
        gdata2.widthHint = 400;
        resultLabel.setLayoutData(gdata2);

        table.setLayoutData(gdata);

        resultTable = new Table(resultPanel, SWT.NULL);

        GridData gdata3 = new GridData();
        gdata3.widthHint = 370;
        gdata3.heightHint = 200;
        resultTable.setLayoutData(gdata3);
        resultTab.setControl(resultPanel);

        popMenu = new Menu(shell, SWT.POP_UP);
        MenuItem mitem = new MenuItem(popMenu, SWT.PUSH);
        mitem.setText("tH_[̒ǉ");
        mitem.addSelectionListener(this);

        MenuItem mitem2 = new MenuItem(popMenu, SWT.PUSH);
        mitem2.setText("tH_[ȉǉ");
        mitem2.addSelectionListener(this);

        MenuItem sep = new MenuItem(popMenu, SWT.SEPARATOR);

        MenuItem mitem3 = new MenuItem(popMenu, SWT.PUSH);
        mitem3.setText("Iڂ폜");
        mitem3.addSelectionListener(this);
        
        MenuItem mitem4 = new MenuItem(popMenu, SWT.PUSH);
        mitem4.setText("ׂĂ̍ڂ폜");
        mitem4.addSelectionListener(this);

        table.setMenu(popMenu);
        //test

        Button exec = new Button(panel, SWT.NULL);
        exec.setText("ׂ");
        exec.addSelectionListener(this);

        //execSetRoot("C:\\tmp\\media\\base");

       // addFolder(new File("C:\\tmp\\media\\ok1"));
        //addFolder(new File("C:\\tmp\\media\\ok2"));
        //addFolder(new File("C:\\tmp\\media\\ng1"));
        //addFolder(new File("C:\\tmp\\media\\ng2"));
    }

    /**
     *  
     */
    private void initImage() {
        okImage = new Image(Display.getCurrent(), FindSameFolderMain.class.getClassLoader()
                .getResourceAsStream(
                        "org/jpn/xucker/findsame/resource/ok.png"));
        ngImage = new Image(Display.getCurrent(), FindSameFolderMain.class.getClassLoader()
                .getResourceAsStream(
                        "org/jpn/xucker/findsame/resource/ng.png"));
        yetImage = new Image(Display.getCurrent(), FindSameFolderMain.class.getClassLoader()
                .getResourceAsStream(
                        "org/jpn/xucker/findsame/resource/yet.png"));

    }

    public void doSetRoot() {
        DirectoryDialog dialog = new DirectoryDialog(shell);
        String dir = dialog.open();
        if (dir != null) {
            execSetRoot(dir);
        }
    }
    
    public void doRefresh() {
        String dir = rootLabel.getText();
        if (!dir.equals("")) {
            execSetRoot(dir);
        }
    }

    public void execSetRoot(String dir) {
        rootLabel.setText(dir);
        loadRootHash(new File(dir));
    }

    public void loadRootHash(File folder) {
        rootHash = new Hashtable();
        if (folder.isDirectory()) {
            String list[] = folder.list();
            if(list!=null){
            for (int i = 0; i < list.length; i++) {
                pushMD5(folder, new File(folder, list[i]));
            }
            }
        }
    }

    public void checkFolder(TableItem item) {
        File destFolder = new File(item.getText());
        Vector errorList = new Vector();
        //check & add log.
        String rootKeys[] = (String[]) rootHash.keySet().toArray(
                new String[rootHash.size()]);
        Arrays.sort(rootKeys);

        for (int i = 0; i < rootKeys.length; i++) {
            File destFile = new File(destFolder, rootKeys[i]);
            if (!destFile.exists()) {
                errorList.addElement(new Error(Error.NOT_FOUND_DEST,
                        rootKeys[i]));
            } else {

                try {
                    String newMD5 = MD5Util.toMD5(destFile);
                    if (!newMD5.equals((String) rootHash.get(rootKeys[i]))) {
                        errorList.add(new Error(Error.MD5, rootKeys[i]));
                    }
                } catch (IOException e) {
                    // TODO Auto-generated catch block
                    errorList.add(new Error(Error.MD5, rootKeys[i]));
                    e.printStackTrace();
                }

            }
        }
        Error[] errors = (Error[]) errorList
                .toArray(new Error[errorList.size()]);
        errorHash.put(destFolder.getAbsolutePath(), errors);
        //setresult icon
        if (errors.length > 0) {
            item.setImage(ngImage);
        } else {
            item.setImage(okImage);
        }
    }

    public void pushMD5(File root, File file) {
        if (file.isDirectory()) {
            String list[] = file.list();
            if(list!=null){
            for (int i = 0; i < list.length; i++) {
                pushMD5(root, new File(file, list[i]));
            }
            }

        } else {
            try {
                String md5 = MD5Util.toMD5(file);
                String path = parsePath(root, file);
                //System.out.println(path + "," + md5);
                rootHash.put(path, md5);
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }

    /**
     * @param root
     * @param file
     * @return
     */
    private String parsePath(File root, File file) {
        String rootPath = root.getAbsolutePath();
        if (!rootPath.endsWith(System.getProperty("file.separator"))) {
            rootPath += System.getProperty("file.separator");
        }
        String newPath = file.getAbsolutePath();
        if (!newPath.startsWith(rootPath)) {
            throw new RuntimeException("wrong path mixed " + rootPath + ","
                    + newPath);
        }
        return newPath.substring(rootPath.length());
    }

    public void doAddFolder() {
        DirectoryDialog dialog = new DirectoryDialog(shell);
        String dir = dialog.open();
        if (dir != null) {
            addFolder(new File(dir));
        }
    }

    /**
     * @param file
     */
    private void addFolder(File file) {
        TableItem tableItem = new TableItem(table, SWT.NULL);
        tableItem.setImage(yetImage);

        tableItem.setText(file.getAbsolutePath());

    }

    public void doDeleteFolder() {
        int select[] = table.getSelectionIndices();
        table.remove(select);
    }
    
    public void doDeleteAll() {
        int select[] = table.getSelectionIndices();
        table.removeAll();
    }

    public void doAddMultiFolder() {
        DirectoryDialog dialog = new DirectoryDialog(shell);
        String dir = dialog.open();
        if (dir != null) {
            File file=new File(dir);
            if(file.isDirectory()){
                String list[]=file.list();
                if(list!=null){
                for(int i=0;i<list.length;i++){
                    File tmp=new File(file,list[i]);
                    if(tmp.isDirectory()){
                        addFolder(tmp);
                    }
                    
                }
                }
            }
        }
    }

    public static void main(String[] args) {
        Display display = new Display();
        Shell shell = new Shell(display);

        FindSameFolderMain button = new FindSameFolderMain(args, shell);

        shell.pack();
        shell.open();

        while (!shell.isDisposed()) {
            if (!display.readAndDispatch()) {
                display.sleep();
            }
        }
        display.dispose();
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.swt.events.SelectionListener#widgetSelected(org.eclipse.swt.events.SelectionEvent)
     */
    public void widgetSelected(SelectionEvent item) {
        if (item.getSource() instanceof MenuItem) {
            MenuItem menuItem = (MenuItem) item.getSource();
            //System.out.println(menuItem.getText());
            if ("tH_[̒ǉ".equals(menuItem.getText())) {
                doAddFolder();
            } else if ("tH_[ȉǉ".equals(menuItem.getText())) {
                doAddMultiFolder();
            } else if ("Iڂ폜".equals(menuItem.getText())) {
                doDeleteFolder();
            }else if ("ׂĂ̍ڂ폜".equals(menuItem.getText())) {
                doDeleteAll();
            }
            
            
            
            
        } else if (item.getSource() instanceof Button) {
            Button bt = (Button) item.getSource();
            if (bt.getText().equals("ׂ")) {
                doCheck();
            } else if (bt.getText().equals("I")) {
                doSetRoot();
            }
            else if (bt.getText().equals("ēǂݍ")) {
                doRefresh();
            }
            
        } else if (item.getSource() instanceof TabFolder) {

            TabFolder tab = (TabFolder) item.getSource();
            int index = tab.getSelectionIndex();
            if (index == 1) {
                showResult();
            }
        }
    }

    /**
     *  
     */
    private void showResult() {

        TableItem items[] = table.getSelection();

        resultTable.removeAll();
        if (items.length > 0) {
            resultLabel.setText(items[0].getText());
           // System.out.println(items[0].getText());
            Error[] errors = (Error[]) errorHash.get(items[0].getText());
            resultLabel.redraw();
            if (errors != null && errors.length > 0) {
                for (int i = 0; i < errors.length; i++) {
                    TableItem ti = new TableItem(resultTable, SWT.NULL);
                    if (errors[i].getType() == Error.MD5) {
                        ti.setText("eႢ܂:" + errors[i].getPath());
                    } else if (errors[i].getType() == Error.NOT_FOUND_DEST) {
                        ti.setText("t@C܂:" + errors[i].getPath());
                    }
                }
            }
        } else {
            resultLabel.setText("");
        }

    }

    

    /**
     *  
     */
    private void doCheck() {
        TableItem items[] = table.getItems();
        for (int i = 0; i < items.length; i++) {
            checkFolder(items[i]);
        }
        //shell.redraw();
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent)
     */
    public void widgetDefaultSelected(SelectionEvent arg0) {

    }

}